/*
- la dashbord corrente che vede diminuito di uno il suo ordine (si sposta su)
 - le altre vengono ricalcolate di conseguenza, mantenedo gli ordini relativi
 - rimane il vincolo tale la seconda dahsboard non puo essere spostata su (al posto della predefinita)
 - rimane il vincolo tale per cui la dashboard predefinita rimane sempre in prima posizione con order 1
*/

import org.springframework.jdbc.datasource.DataSourceTransactionManager;
import org.springframework.transaction.TransactionDefinition;
import org.springframework.transaction.TransactionStatus;
import org.springframework.transaction.support.DefaultTransactionDefinition;
	
def result = [:];
 
def success = false;
def message = null;

final String CLASS_NAME = "dcs_dashboard";
final String CLASS_TABLE_NAME = "dcs_dashboard";

final String R_CLASS_NAME = "dcs_r_dashboard_set_dashboard";
final String R_CLASS_TABLE_NAME = "dcs_r_dashboard_set_dashboard";

DefaultTransactionDefinition dtd = new DefaultTransactionDefinition();
dtd.setPropagationBehavior(TransactionDefinition.PROPAGATION_REQUIRED);
TransactionStatus status = dataSourceTransactionManager.getTransaction(dtd);

try{
 
	//access incoming parameters retrieving from parameterMap
	var gwClassName = parameterMap.gwClassName;
	var itemId = Integer.parseInt(parameterMap.itemId);
	var cod_dashboard_set = parameterMap.codDashboardSet;
	if(cod_dashboard_set==null) throw new RuntimeException("missing required parameter 'codDashboardSet'");
	
	String query = "SELECT * FROM "+CLASS_TABLE_NAME+" WHERE id_dashboard=#{map.id_dashboard}";
	def dashboard = services.queryService.executeQuery(query, [id_dashboard: itemId])[0];
	var cod_dashboard = dashboard.cod_dashboard;
	
	query = "SELECT * FROM "+R_CLASS_TABLE_NAME+" WHERE cod_dashboard=#{map.cod_dashboard} AND cod_dashboard_set=#{map.cod_dashboard_set}";
	def r_dashboard_set_dashboard = services.queryService.executeQuery(query, [cod_dashboard: cod_dashboard, cod_dashboard_set: cod_dashboard_set])[0];
	var dashboard_order = r_dashboard_set_dashboard.dashboard_order;
	
	if(dashboard_order<=2){
		throw new RuntimeException("Non è possibile spostare sù di uno ne la prima dashboard, la principale, ne la seconda, che andrebbe al posto della principale");
	}
	
	//select all inside the cod_dashboard_set ordered
	query = "SELECT * FROM "+R_CLASS_TABLE_NAME+" WHERE cod_dashboard_set=#{map.cod_dashboard_set} ORDER BY dashboard_order";
	def dashboardList = services.queryService.executeQuery(query, [cod_dashboard_set: cod_dashboard_set, cod_dashboard: cod_dashboard]);
	def newOrder = dashboard_order-1;
	def aboveDashboard = dashboardList.get(newOrder-1);
	
	//and reorder inverting the current and the above one
	//set newOrder to this dashboard
	query = "UPDATE "+R_CLASS_TABLE_NAME+" SET dashboard_order=#{map.dashboard_order} WHERE cod_dashboard_set=#{map.cod_dashboard_set} AND cod_dashboard=#{map.cod_dashboard}";
	services.queryService.executeUpdateQuery(query, [dashboard_order: newOrder, cod_dashboard_set: cod_dashboard_set, cod_dashboard: cod_dashboard]);
	
	//set old order to the above dashboard
	query = "UPDATE "+R_CLASS_TABLE_NAME+" SET dashboard_order=#{map.dashboard_order} WHERE cod_dashboard_set=#{map.cod_dashboard_set} AND cod_dashboard=#{map.cod_dashboard}";
	services.queryService.executeUpdateQuery(query, [dashboard_order: dashboard_order, cod_dashboard_set: aboveDashboard.cod_dashboard_set, cod_dashboard: aboveDashboard.cod_dashboard]);
	
	services.gwMetadataCacheService.clearAllStartingWith("gwDashboardSetService_");
	
	dataSourceTransactionManager.commit(status);
	
	//set success to true
	success = true;
	message = 'OK';
 
}catch(Exception e){
	//something goes wrong
	log.error(e.getMessage(), e); //log it
	
	dataSourceTransactionManager.rollback(status);
	
	success = false; //set flag to false
	message = e.getMessage();
}finally{
	result.success = success;
	result.message = message;
}
 
return result;