//user:    GSC
//date:    18/11/2024
//ver:     1.0.0
//class:   dcs_dashboard
//note:    dcs_dashboard event trigger

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.io.xml.StaxDriver;
import com.thoughtworks.xstream.security.AnyTypePermission;
import com.thoughtworks.xstream.io.StreamException;
import com.geowebframework.transfer.model.projects.*;

	

public class dcsDashboardEventTrigger extends com.geowebframework.dataservice.querybuilder.EventTrigger {
	
	final String CLASS_NAME = "dcs_dashboard";
	final String CLASS_TABLE_NAME = "dcs_dashboard";
	
	public boolean beforeInsert(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - beforeInsert()");
		
		String radix = "DSH_BRD_";
		String cod = "cod_dashboard";
		Integer leadingZeros = 6;
		String leadedInt = String.format("%0"+leadingZeros+"d", 1);
		String query = "SELECT "+cod+" FROM "+CLASS_TABLE_NAME+" ORDER BY "+cod+" asc";
		def res = services.queryService.executeQuery(query, null);
		if(res.size()!=0){
			String cod_model_last = res[res.size()-1][cod];
			Integer lastInt = Integer.parseInt(cod_model_last.substring(cod_model_last.indexOf(radix)+radix.length()));
			lastInt++;
			leadedInt = String.format("%0"+leadingZeros+"d", lastInt);
		}
		String newCod = radix+leadedInt;
		valuesMap[cod] = newCod;
		
		
		String xml = valuesMap.xml;
		if(xml!=null && !xml.isEmpty()){
			
			XStream xstream = new XStream(new StaxDriver());
			xstream.addPermission(AnyTypePermission.ANY); //issue #589
			//xstream.ignoreUnknownElements(); // better to not ignore unknown tags here
			
			xstream.processAnnotations(LeafItem.class);
			xstream.processAnnotations(Parameter.class);
			xstream.processAnnotations(KeyValuePair.class);
			
			xstream.allowTypeHierarchy(LeafItem.class); //issue #589
			xstream.allowTypeHierarchy(Parameter.class); //issue #589
			xstream.allowTypeHierarchy(KeyValuePair.class); //issue #589
			
			try{
			
				LeafItem leafItem = (LeafItem) xstream.fromXML(xml);
				
				String image = leafItem.getImage();
				valuesMap.icon_string = image;
				
				if(valuesMap.label_dashboard==null) valuesMap.label_dashboard = leafItem.getLabel();
				
			}catch(StreamException e){
				throw new RuntimeException("Wrong xml fomat");
			}
			
		}
		
		if(valuesMap.is_custom==null) valuesMap.is_custom = 0;
		
		return true;
	};
	
	public boolean afterInsert(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - afterInsert()");
		return true;
	};
	
	public boolean beforeUpdate(HashMap<String,Object> valuesMap, HashMap<String,Object> oldvaluesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - beforeUpdate()");
		
		String xml = valuesMap.xml;
		if(xml!=null && !xml.isEmpty()){
			
			XStream xstream = new XStream(new StaxDriver());
			xstream.addPermission(AnyTypePermission.ANY); //issue #589
			//xstream.ignoreUnknownElements(); // better to not ignore unknown tags here
			
			xstream.processAnnotations(LeafItem.class);
			xstream.processAnnotations(Parameter.class);
			xstream.processAnnotations(KeyValuePair.class);
			
			xstream.allowTypeHierarchy(LeafItem.class); //issue #589
			xstream.allowTypeHierarchy(Parameter.class); //issue #589
			xstream.allowTypeHierarchy(KeyValuePair.class); //issue #589
			
			try{
				LeafItem leafItem = (LeafItem) xstream.fromXML(xml);
				
				String image = leafItem.getImage();
				valuesMap.icon_string = image;
			}catch(StreamException e){
				throw new RuntimeException("Wrong xml fomat");
			}
			
		}
		
		return true;
	};
	
	public boolean afterUpdate(HashMap<String,Object> valuesMap,HashMap<String,Object> oldvaluesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - afterUpdate()");
		return true;
	};
	
	public boolean beforeDelete(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - beforeDelete()");
		return true;
	};
	
	public boolean afterDelete(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - afterDelete()");
		return true;
	};

} 