//user:    GSC
//date:    18/11/2024
//ver:     1.0.0
//class:   dcs_gwa_func
//note:    dcs_gwa_func event trigger
	

public class dcsGwaFuncEventTrigger extends com.geowebframework.dataservice.querybuilder.EventTrigger {
	
	final String CLASS_NAME = "dcs_gwa_func";
	final String CLASS_TABLE_NAME = "dcs_gwa_func";
	
	
	public boolean beforeInsert(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - beforeInsert()");
		
		//check if this.gwa func code had already been taken
		String cod_func = valuesMap.cod_func;
		if(cod_func==null) throw new RuntimeException("Missing required paramter 'cod_func'");
		String query = "SELECT cod_func FROM "+CLASS_TABLE_NAME;
		def res = services.queryService.executeQuery(query, null);
		if(res.size()!=0){
			Boolean found = false;
			res.each { r ->
				if(r.cod_func==cod_func) found = true;
			};
			if(found) throw new RuntimeException("The App with cod_func: '"+cod_func+"', is already enabled. Choose another one.");
		}
		
		return true;
	};
	
	public boolean afterInsert(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - afterInsert()");
		return true;
	};
	
	public boolean beforeUpdate(HashMap<String,Object> valuesMap, HashMap<String,Object> oldvaluesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - beforeUpdate()");
		
		//check if this.gwa func code had already been taken
		String id_dcs_gwa_func = oldvaluesMap.id_dcs_gwa_func;
		String cod_func = valuesMap.cod_func;
		if(cod_func!=null){
			String query = "SELECT cod_func FROM "+CLASS_TABLE_NAME;
			def res = services.queryService.executeQuery(query, null);
			if(res.size()!=0){
				Boolean found = false;
				res.each { r ->
					if(r.cod_func==cod_func && r.id_dcs_gwa_func!=id_dcs_gwa_func) found = true;
				};
				if(found) throw new RuntimeException("The App with cod_func: '"+cod_func+"', is already enabled. Choose another one.");
			}
		}
		
		return true;
	};
	
	public boolean afterUpdate(HashMap<String,Object> valuesMap,HashMap<String,Object> oldvaluesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - afterUpdate()");
		return true;
	};
	
	public boolean beforeDelete(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - beforeDelete()");
		return true;
	};
	
	public boolean afterDelete(HashMap<String,Object> valuesMap){
		log.debug("gwClassName: "+CLASS_NAME+" - afterDelete()");
		return true;
	};

} 